c basiscu.f, (Aug 12 1995)
c This file contains function FNULL to compute all the null space 
c basis functions and function RK to compute reproducing kernel,
c for cubic splines on [0,1].
c ----------------------------------------------------------------------
c   null space basis functions 
      DOUBLE PRECISION FUNCTION FNULL (M,X)
      INTEGER M
      DOUBLE PRECISION X
      IF(M .EQ. 1) THEN
         FNULL = 1.D0
      ELSEIF(M .EQ. 2) THEN
         FNULL = X - .5D0
      ELSE
         WRITE(*,*) "Error: null space basis function inconsistency"
      ENDIF
      RETURN
      END

c   reproducing kernel 
      DOUBLE PRECISION FUNCTION  RK (Y,X)
      DOUBLE PRECISION  Y, X, DK2, DK4
      RK = DK2 (Y) * DK2 (X) - DK4 (ABS(X-Y))
      RETURN
      END

c   auxiliary function for calculating reproducing kernel
      DOUBLE PRECISION FUNCTION  DK2 (X)
      DOUBLE PRECISION  X
      DK2 = ( X - .5D0 ) ** 2 
      DK2 = ( DK2 - 1.D0 / 12.D0 ) / 2.D0
      RETURN
      END
c   auxiliary function for calculating reproducing kernel
      DOUBLE PRECISION FUNCTION  DK4 (X)
      DOUBLE PRECISION  X
      X = DABS (X)
      DK4 = ( X - .5D0 ) ** 2
      DK4 = ( DK4 ** 2 - DK4 / 2.D0 + 7.D0 / 240.D0 ) / 24.D0
      RETURN
      END
